{%- from 'components/help.html.jinja' import glossary_link, empty_entry -%}
{%- from 'components/metadata.html.jinja' import metadata_item, metadata_card -%}

{% macro sdg_relevant(relevant) %}
  <big class="d-flex flex-row align-items-center gap-1">
    {% if relevant is none %}
      <span class="badge text-bg-light"
        ><i class="bi bi-question-circle"></i> SDG</span
      >
    {% elif relevant %}
      <span class="badge text-bg-primary"
        ><i class="bi bi-check-circle"></i> SDG</span
      >
    {% else %}
      <span class="badge text-bg-light"
        ><i class="bi bi-x-circle"></i> SDG</span
      >
    {% endif %}
  </big>
{% endmacro %}

{% macro metadata(metadata) %}
  <h2 class="visually-hidden">Metadaten</h2>
  {% call metadata_item("Quellredaktion", "https://docs.fitko.de/fim/docs/glossar/#quellredaktion") %}
    {{ metadata.redaktion_label }}
  {% endcall %}

  {% call metadata_item("Datenquelle", "https://docs.fitko.de/fim/docs/quer/fim_portal_sources/") %}
    {{ metadata.datenquelle }}
  {% endcall %}

  {% call metadata_item("Erstellt am", none) %}
    {% if metadata.erstellt_am %}
      {{ metadata.erstellt_am }}
    {% else %}
      {{ empty_entry() }}
    {% endif %}
  {% endcall %}

  {% call metadata_item("Geändert am", none) %}
    {% if metadata.geaendert_am %}
      {{ metadata.geaendert_am }}
    {% else %}
      {{ empty_entry() }}
    {% endif %}
  {% endcall %}

  {% call metadata_item("Version", none) %}
    {% if metadata.version %}
      {{ metadata.version }}
    {% else %}
      {{ empty_entry() }}
    {% endif %}
  {% endcall %}
{% endmacro %}

{% macro steckbrief(steckbrief) %}
  {# Ordered in the same order as the "Musterformular Leistungsbeschreibungen" from fimportal.de/fim-haus #}
  <div class="mb-4">
    {% call simple_leistung_attribute("Leistungsschlüssel", "https://docs.fitko.de/fim/docs/glossar#leistungsschl%C3%BCssel-lsl") %}
      {% if steckbrief.leistungsschluessel %}
        {{ steckbrief.leistungsschluessel }}
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% call simple_leistung_attribute("Leistungsbezeichnung", "https://docs.fitko.de/fim/docs/glossar/#leistungsbezeichnung1") %}
      {% if steckbrief.leistungsbezeichnung %}
        {{ steckbrief.leistungsbezeichnung }}
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% call simple_leistung_attribute("Leistungsbezeichnung II", "https://docs.fitko.de/fim/docs/glossar/#leistungsbezeichnung2") %}
      {% if steckbrief.leistungsbezeichnung_II %}
        {{ steckbrief.leistungsbezeichnung_II }}
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% call simple_leistung_attribute("Leistungstypisierung", "https://docs.fitko.de/fim/docs/glossar#typisierung") %}
      {% if steckbrief.typisierung %}
        {{ steckbrief.typisierung }}
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% call simple_leistung_attribute("Begriffe im Kontext", none) %}
      {% if steckbrief.begriffe_im_kontext %}
        {{ steckbrief.begriffe_im_kontext }}
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% call simple_leistung_attribute("Leistungstyp", "https://docs.fitko.de/fim/docs/glossar/#leistungstyp") %}
      {% if steckbrief.leistungsstruktur %}
        {{ steckbrief.leistungsstruktur.leistungstyp }}
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% if steckbrief.leistungsstruktur %}
      {% for item in steckbrief.leistungsstruktur.attribute %}
        {% call simple_leistung_attribute(item.title, item.help_link) %}
          {{ item.value }}
        {% endcall %}
      {% endfor %}
    {% endif %}

    {% call simple_leistung_attribute("SDG Informationsbereiche", "https://docs.fitko.de/fim/docs/glossar/#sdg-informationsbereich") %}
      {% if steckbrief.sdg_informationsbereiche %}
        <ul class="list-unstyled mb-0">
          {% for item in steckbrief.sdg_informationsbereiche %}
            <li>{{ item }}</li>
          {% endfor %}
        </ul>
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% call simple_leistung_attribute("Lagen Portalverbund", "https://docs.fitko.de/fim/docs/glossar/#lagenportalverbund") %}
      {% if steckbrief.lagen_portalverbund %}
        <ul class="list-unstyled mb-0">
          {% for item in steckbrief.lagen_portalverbund %}
            <li>{{ item }}</li>
          {% endfor %}
        </ul>
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% call simple_leistung_attribute("Einheitlicher Ansprechpartner", "https://docs.fitko.de/fim/docs/glossar/#einheitlicher-ansprechpartner") %}
      {% if steckbrief.einheitlicher_ansprechpartner is not none %}
        {% if steckbrief.einheitlicher_ansprechpartner %}
          Ja
        {% else %}
          Nein
        {% endif %}
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% call simple_leistung_attribute("Fachlich freigegeben am", none) %}
      {% if steckbrief.fachlich_freigegeben_am %}
        {{ steckbrief.fachlich_freigegeben_am }}
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}

    {% call simple_leistung_attribute("Fachlich freigegeben durch", none) %}
      {% if steckbrief.fachlich_freigegeben_durch %}
        {{ steckbrief.fachlich_freigegeben_durch }}
      {% else %}
        {{ empty_entry() }}
      {% endif %}
    {% endcall %}
  </div>
{% endmacro %}

{% macro translations(translations) %}
  {% call metadata_card("Sprache", none) %}
    <div class="nav nav-pills flex-column gap-1 p-2">
      {% for translation in translations %}
        <a
          href="{{ translation.href }}"
          {% if translation.active %}
            class="nav-link active" aria-current="page"
          {% else %}
            class="nav-link"
          {% endif %}
          >{{ translation.label }}</a
        >
      {% endfor %}
    </div>
  {% endcall %}
{% endmacro %}

{% macro sidebar_navigation(sidebar_navigation) %}
  <aside
    class="d-none d-xxl-block sidebar"
    role="navigation"
    aria-label="Inhaltsverzeichnis"
  >
    <div class="sidebar-content">
      <div class="container pt-3">
        <h2 class="text-muted small">Verzeichnis</h2>
        <ul class="nav nav-pills flex-column">
          {% for item in sidebar_navigation %}
            <li class="nav-item">
              <a
                class="nav-link d-flex flex-row justify-content-between align-items-center"
                href="{{ item.href }}"
              >
                <span>{{ item.label }}</span>
                {% if item.icon == "error" %}
                  {# <i class="bi text-danger bi-exclamation-diamond-fill"></i> #}
                  <i class="bi text-secondary bi-dash-circle"></i>
                {% elif item.icon == "empty" %}
                  <i class="bi text-secondary bi-dash-circle"></i>
                {% endif %}
              </a>
            </li>
          {% endfor %}
        </ul>
      </div>
    </div>
  </aside>
{% endmacro %}

{%- macro render_modul_content(content) -%}
  {% if content.type == "text" %}
    {% if content.inhalt %}
      <div class="between-3">{{ content.inhalt|safe }}</div>
    {% endif %}
    {% if content.links %}
      <ul>
        {% for link in content.links %}
          <li>
            <a href="{{ link.href }}">{{ link.label }}</a>
          </li>
        {% endfor %}
      </ul>
    {% endif %}
  {% elif content.type == "kosten" %}
    {% for kosten in content.kosten %}
      <div class="d-flex flex-column">
        <span>
          {{ kosten.kostentyp }}:
          <b>{{ kosten.kosten_value }}</b>
          {% if kosten.kosten_value_details %}
            ({{ kosten.kosten_value_details }})
          {% endif %}
        </span>
        {% if kosten.beschreibung %}
          <div>{{ kosten.beschreibung|safe }}</div>
        {% endif %}
        {% if kosten.vorkasse %}
          <span class="text-muted">Zahlung nur mit Vorkasse</span>
        {% endif %}
        {% if kosten.link_kostenbildung %}
          <a
            href="{{ kosten.link_kostenbildung }}"
            target="_blank"
            aria-label="Mehr erfahren (öffnet in neuem Tab)"
            >Mehr erfahren</a
          >
        {% endif %}
      </div>
    {% endfor %}

    {% if content.beschreibung %}
      <div class="between-3">{{ content.beschreibung|safe }}</div>
    {% endif %}
    {% if content.links %}
      <ul class="mb-0">
        {% for link in content.links %}
          <li>
            <a href="{{ link.href }}">{{ link.label }}</a>
          </li>
        {% endfor %}
      </ul>
    {% endif %}
  {% elif content.type == "frist" %}
    {% for frist in content.frist %}
      <div class="d-flex flex-column">
        <span>{{ frist.typ }}: <b>{{ frist.frist_value }}</b></span>
        {% if frist.beschreibung %}
          <div>{{ frist.beschreibung|safe }}</div>
        {% endif %}
      </div>
    {% endfor %}

    {% if content.beschreibung %}
      <div class="between-3">{{ content.beschreibung|safe }}</div>
    {% endif %}
    {% if content.links %}
      <ul>
        {% for link in content.links %}
          <li>
            <a href="{{ link.href }}">{{ link.label }}</a>
          </li>
        {% endfor %}
      </ul>
    {% endif %}
  {% elif content.type == "ursprung" %}
    <div>
      <a
        href="{{ content.uri }}"
        target="_blank"
        aria-label="{{ content.titel }} (öffnet in neuem Tab)"
        >{{ content.titel }}</a
      >
    </div>
  {% elif content.type == "bearbeitungsdauer" %}
    {% for frist in content.bearbeitungsdauer %}
      <div class="d-flex flex-column">
        <b>{{ frist.frist_value }}</b>
        {% if frist.beschreibung %}
          <div>{{ frist.beschreibung|safe }}</div>
        {% endif %}
      </div>
    {% endfor %}

    {% if content.beschreibung %}
      <div class="between-3">{{ content.beschreibung|safe }}</div>
    {% endif %}
    {% if content.links %}
      <ul>
        {% for link in content.links %}
          <li>
            <a href="{{ link.href }}">{{ link.label }}</a>
          </li>
        {% endfor %}
      </ul>
    {% endif %}
  {% endif %}
{%- endmacro -%}

{%- macro render_modul(modul) -%}
  {% if modul %}
    <div class="mb-4">
      <div class="d-flex flex-row gap-2 align-items-end mb-2">
        <h3 class="fs-5 mb-0 d-inline" id="{{ modul.id }}">
          {{ modul.title }}
        </h3>
        {% if modul.glossary_link %}
          {{ glossary_link(modul.glossary_link, modul.title) }}
        {% endif %}
      </div>
      <div class="p-3 between-3 bg-body-tertiary rounded">
        {% if modul.content %}
          {{ render_modul_content(modul.content) }}
        {% elif modul.is_required %}
          {{ empty_entry() }}
        {% else %}
          {{ empty_entry() }}
        {% endif %}
      </div>
    </div>
  {% endif %}
{%- endmacro -%}

{% macro simple_leistung_attribute(title, link) %}
  <div class="row mb-2">
    <div class="col-12 col-xl-4">
      <h3 class="fs-6 mb-0">
        {{ title }}
        {% if link %}
          {{ glossary_link(link, title) }}
        {% endif %}
      </h3>
    </div>
    <div class="col-12 col-xl-8">{{ caller() }}</div>
  </div>
{% endmacro %}
